V2 = {}
V2.mt = {}
function V2.new(xx, yy)
	local set = {x = xx, y = yy}
	setmetatable(set, V2.mt)
	return set
end
function V2.print (s)
	print(V2.tostring(s))
end
function V2.mt.__add(a,b)
	local res = V2.new{}
	if getmetatable(a)~=V2.mt then
		return error("Error: Cannot Add "..type(a).." And V2", 2)
		--for k in pairs(a) do res[k] = b[k]+a end
	elseif getmetatable(b)~=V2.mt then
		return error("Error: Cannot Add V2 And "..type(b), 2)
		--for k in pairs(a) do res[k] = a[k]+b end
	else
		for k in pairs(a) do res[k] = a[k]+b[k] end
	end
	return res
end
function V2.mt.__mul(a,b)
	local res = V2.new{}
	if getmetatable(a)~=V2.mt then
		for k in pairs(b) do res[k] = b[k]*a end
	elseif getmetatable(b)~=V2.mt then
		for k in pairs(a) do res[k] = a[k]*b end
	else
		for k in pairs(a) do res[k] = a[k]*b[k] end
	end
	return res
end
function V2.mt.__sub(a,b)
	local res = V2.new{}
	if getmetatable(a)~=V2.mt then
		--return error("Error: Cannot Subject "..type(a).." And V2", 2)
		for k in pairs(b) do res[k] = b[k]+a end
	elseif getmetatable(b)~=V2.mt then
		--return error("Error: Cannot Subtract V2 And "..type(b), 2)
		for k in pairs(a) do res[k] = a[k]+b end
	else
		for k in pairs(a) do res[k] = a[k]-b[k] end
	end
	return res
end
function V2.mt.__div(a,b)
	local res = V2.new{}
	if getmetatable(a)~=V2.mt then
		for k in pairs(a) do res[k] = b[k]/a end
	elseif getmetatable(b)~=V2.mt then
		for k in pairs(a) do res[k] = a[k]/b end
	else
		for k in pairs(a) do res[k] = a[k]/b[k] end
	end
	return res
end
function V2.mt.__pow(a,b)
	local res = V2.new{}
	if getmetatable(a)~=V2.mt then
		for k in pairs(a) do res[k] = b[k]^a end
	elseif getmetatable(b)~=V2.mt then
		for k in pairs(a) do res[k] = a[k]^b end
	else
		for k in pairs(a) do res[k] = a[k]^b[k] end
	end
	return res
end
print("V2 Object Loaded!")