
function love.load()
	require("Vector2.lua")
	finishedgrid = {
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0},
		{0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0},
		{0,1,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,1,0},
		{0,0,0,0,1,1,0,0,1,1,0,1,0,0,0,0,0,0,0,0},
		{0,0,0,0,1,1,0,0,0,1,1,0,0,0,1,1,1,1,0,0},
		{0,0,0,0,0,1,1,0,1,1,0,0,0,0,1,0,0,1,0,0},
		{0,0,1,0,0,1,1,1,1,1,0,0,0,0,1,0,1,1,0,0},
		{0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0},
		{0,1,0,0,0,0,1,1,1,0,0,1,0,0,1,1,0,0,0,0},
		{0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,0,0,0,1},
		{0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1},
		{0,1,0,1,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1},
		{0,1,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1},
		{1,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		}
	
	rgrid = {}
	for y = 1, 20 do
		rgrid[y] = {}
		for x = 1, 20 do
			rgrid[y][x] = 0
		end
	end
	squarex = 20
	squarey = 20
	squarefall = 1 --start at 0
	done = false
	nxt = false
end
function wait(t)
	love.timer.sleep(1000*t)
end
function love.draw()
	local gr = love.graphics
	local ww = gr.getWidth()
	local wh = gr.getHeight()
	gr.setBackgroundColor(255, 255, 255)
	gr.setColor(0, 0, 0, 255)
	sy = wh/#rgrid
	sx = ww/#rgrid[1]
	gr.setLineWidth(1)
	for y, r in pairs(rgrid) do
		for x, v in pairs(r) do
			if v == 1 then gr.setColor(0, 0, 255, 255) else gr.setColor(0, 0, 0, 255) end
			local xx = sx*(x-1)
			local yy = sy*(y-1)
			gr.rectangle("fill", xx, yy, sx, sy)
			gr.setColor(255, 255, 255, 255)
			gr.rectangle("line", xx, yy, sx, sy)
		end
	end
	local xx = sx*(squarex-1)
	local yy = sy*(squarefall-1)
	gr.setColor(0, 0, 255, 255)
	gr.rectangle("fill", xx, yy, sx, sy)
end
function shiftalong()
	squarex = squarex-1
	if squarex<1 then
		squarex = 20 --back up
		squarey = squarey-1 --up a bar (y goes from top to bottom)
		if squarey<1 then
			done = true
		end
	end
	if done == false then
		if finishedgrid[squarey][squarex] == 0 then
			shiftalong()
		else
			return --done :3
		end
	end
end
function love.update(dt)
	if done == false then
		--wait(0.001)
		if nxt == true then
			shiftalong()
			squarefall = 1
			nxt = false
		else
			squarefall = squarefall+1
			if squarefall>=squarey then
				rgrid[squarey][squarex] = 1 --set square
				nxt = true --next square
			end
		end
	end
end

function love.run()
 
    if love.load then love.load() end
 
    -- Main loop.
    while true do
 
        love.timer.step()
        if love.update then love.update(love.timer.getDelta()) end
        love.graphics.clear()
        if love.draw then love.draw() end
 
        -- Process events.
        for e,a,b,c in love.event.poll() do
            if e == 'q' then
                if love.audio then
                    love.audio.stop()
                end
                return
            end
            love.handlers[e](a,b,c)
        end
        love.timer.sleep(1)
 
        love.graphics.present()
 
    end
 
end