
function love.load()
	require("Vector2.lua")
	old = nil
	rot = 0
	Change = 0.9
	stars = {}
	for i = 1, 500 do
		local d = math.pi*2/360*math.random(1, 360)
		table.insert(stars, {p = V2.new(love.graphics.getWidth()/2, love.graphics.getHeight()/2), v = V2.new(math.sin(d)*4, math.cos(d)*4), s = 1+math.random(1, 10), a = 1+math.random(1, 5)})
	end
	waitcount = 0
	waitfor = 100 --HOW LONG TO LOAD
end
function love.draw()
	local gr = love.graphics
	local ww = gr.getWidth()/2
	local wh = gr.getHeight()/2
	gr.setBackgroundColor(0, 0, 0)
	if old ~=nil then
		gr.draw(old, ww, wh, rot, 1, 1,ww, wh)
	end
	gr.setColor(255, 255, 255, 255)
	for i, j in pairs(stars) do
		local p = j.p
		local v = j.v
		local a = j.a
		local s = j.s
		local op = V2.new(p.x, p.y)
		j.s = s*a
		v.x = v.x*a
		v.y = v.y*a
		p.x = p.x+v.x*spd
		p.y = p.y+v.y*spd
		if waitcount>=waitfor then --only render after loading.. (before loading, it looks very crappy)
			gr.setLineWidth(s/400*Change)
			gr.line(op.x, op.y, j.p.x, j.p.y)
			gr.circle("fill", p.x, p.y, s/400*Change, 20)
		else -- will appear during loading:
			--[[ --lol looks like.. sperm XD
			nx = j.p.x+math.random(-5, 5)
			ny = j.p.y+math.random(-5, 5)
			gr.circle("fill", nx, ny, s/50, 5)
			gr.line(op.x+math.random(-3, 3), op.y+math.random(-3, 3), nx ,ny)
			--]]
		end
		if p.x<0 or p.x>ww*2 or p.y<0 or p.y>wh*2 then
			local d = math.pi*2/360*math.random(1, 360)
			j.p = V2.new(ww, wh)
			j.v = V2.new(math.sin(d), math.cos(d))
			j.s = 1.5/3
			j.a = (1+math.random(8, 14)/60)*Change
		end
	end
	
	if waitcount<waitfor then --Loading Screen:
		waitcount = waitcount+1
		percent = 1/waitfor*waitcount
		wid = 20
		barlen = ww/1.3
		st = ww-barlen/2
		len = barlen*percent
		gr.printf("Loading", ww, wh-(wid+5), 0, "center")
		gr.setColor(255, 255, 255, 255/3)
		gr.rectangle("fill", st, wh-20, barlen, wid*2)
		gr.setColor(255, 255, 255, 255)
		gr.rectangle("fill", st, wh-20, len, wid*2)
		
	end
	gr.setColor(0, 0, 0, 100)
	gr.rectangle("fill", 0, 0, ww*2+1, wh*2+1)
	gr.setColor(255, 255, 255, 255)
	SSD = love.graphics.newScreenshot()
	old = love.graphics.newImage(SSD)
end
function love.update(dt)
	spd = dt
end
function love.mousepressed( x, y, button)
	if button == "l" then
	end
end
function love.mousereleased( x, y, button )
	if button == "l" then
	end
end
function love.keypressed(key)
	if key == "w" then --create new shape
	end
end
function love.keyreleased(key)
	if key == "w" then --create new shape
	end
end
